//-----------------------------------------------------------
// smpl14(tc_pwm).c
// TCɂPWMo
//   Copyright (c) BestTechnology CO.,LTD. 2005-2010
//-----------------------------------------------------------
// LED1TIOA0ŖłB
//-----------------------------------------------------------

#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#include <AT91SAM7X.h>
#include <AT91SAM7X_BITDEFINE.h>
#else
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>
#endif

#include <vic.h>
#include <piocfg.h>

// VAʐM֘A
#define __UDP__
#include "share/us.c"

// PIO[qݒ
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
static const TPin pins[] = {
  // PB23 -> TIOA0
  { 1 << 23, &PIOB, PIOB_PID, PIO_PERIPH_A, PIO_PULLUP},
};
#else
static const TPin pins[] = {
  // PA0  -> TIOA0
  {1 <<  0, &PIOA, PIOA_PID, PIO_PERIPH_B, PIO_DEFAULT},
};
#endif

//========================================================
// MISC...
//========================================================
void wait (int n) {
  volatile int i, j;

  for (i = 0; i < n; i++)
    for (j = 0; j < 1000; j++) ;
}

//========================================================
// Timer/Counter0
//========================================================
void TC0_Init (void) {
  PMC.PCER = 1 << TC0_PID; // Enable T0 peripheral clock

  TC.CHANNEL[0].CCR = _TC_CLKDIS;
  TC.CHANNEL[0].IDR = -1;
  TC.CHANNEL[0].SR;

  TC.CHANNEL[0].CMR = _TC_CLKS_MCK_1024;  // /1024
  TC.CHANNEL[0].CMR |= _TC_WAVE | _TC_WAVESEL_UP_AUTO | _TC_ACPC_SET | _TC_ACPA_CLEAR;
  TC.CHANNEL[0].RC = 3000;                // /32/RC
  TC.CHANNEL[0].RA = 500;                 // DUTY=RA/RC

  TC.CHANNEL[0].CCR = _TC_CLKEN | _TC_SWTRG;
}

//========================================================
// main
//========================================================
void main (void) {
  uint32_t v;

  enableIRQ ();

  PIO_Configure (pins, PIO_LISTSIZE (pins));
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));

  TC0_Init ();

  _us_printf ("START!\n\r");

  for (;;)  {
    if (_us_rx_buff ()) {
      switch (_us_getc ()) {
        case 0x1b:
#if defined (__UDP__)
          udp_disconnect ();
          wait(5000);
#endif
          RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
          break;
        case 'U':
          v = TC.CHANNEL[0].RC + 10;
          if (v < TC.CHANNEL[0].RA) v = TC.CHANNEL[0].RA;
          TC.CHANNEL[0].RC = v;
          TC.CHANNEL[0].CCR = _TC_SWTRG;
          break;
        case 'D':
          v = TC.CHANNEL[0].RC - 10;
          if (v < TC.CHANNEL[0].RA) v = TC.CHANNEL[0].RA;
          TC.CHANNEL[0].RC = v;
          TC.CHANNEL[0].CCR =  _TC_SWTRG;
          break;
        case 'u':
          v = TC.CHANNEL[0].RA + 10;
          if (v > TC.CHANNEL[0].RC) v = TC.CHANNEL[0].RC;
          TC.CHANNEL[0].RA = v;
          break;
        case 'd':
          v = TC.CHANNEL[0].RA - 10;
          if (v > TC.CHANNEL[0].RC) v = TC.CHANNEL[0].RC;
          TC.CHANNEL[0].RA = v;
          break;
      }
    }
    _us_printf("\rRA=%5d RC=%5d ", TC.CHANNEL[0].RA, TC.CHANNEL[0].RC);
    wait (100);
  }
}
