//-----------------------------------------------------------
// smpl6(adc).c
// ADϊ
//   Copyright (c) BestTechnology CO.,LTD. 2005-2010
//-----------------------------------------------------------
// AD0`AD7ɓ͂ꂽAiOdvB
//-----------------------------------------------------------

#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#include <AT91SAM7X.h>
#include <AT91SAM7X_BITDEFINE.h>
#else
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>
#endif

#include <vic.h>
#include <piocfg.h>

// VAʐM֘A
#define __UDP__
#include "share/us.c"

// PIO[qݒ
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
static const TPin pins[] = {
  // PA27..30 -> ADC0..3
  {(1 << 27) | (1 << 28) | (1 << 29) | (1 << 30), &PIOB, PIOA_PID, PIO_INPUT, PIO_DEFAULT},
};
#else
static const TPin pins[] = {
  // PA17..20 -> ADC0..3
  {(1 << 17) | (1 << 18) | (1 << 19) | (1 << 20), &PIOA, PIOA_PID, PIO_INPUT, PIO_DEFAULT},
};
#endif

//========================================================
// MISC...
//========================================================
void wait (int n) {
  volatile int i, j;

  for (i = 0; i < n; i++)
    for (j = 0; j < 1000; j++) ;
}

//========================================================
// ADC
//========================================================
// ݒ
bool ADC_Init (void) {

  bool ADC_CfgTimings (
    uint32_t adc_clock,             // in Hz
    uint32_t startup_time,          // in us
    uint32_t sample_and_hold_time)  // in ns
  {
    uint32_t prescal,startup,shtim;

    prescal = (F_CPU / (2 * adc_clock)) - 1;
    startup = ((adc_clock / 1000000) * startup_time / 8) - 1;
    shtim = ((adc_clock / 1000000) * sample_and_hold_time) / 1000;

    if ((prescal < 0x3f) && (startup < 0x7f) && (shtim < 0xf)) {
      ADC.MR = ((prescal << 8) & _ADC_PRESCAL) | ((startup << 16) & _ADC_STARTUP) | ((shtim << 24) & _ADC_SHTIM) | _ADC_LOWRES_10_BIT | _ADC_SLEEP_NORMAL_MODE;
      return true;
    } else {
      return false;
    }
  }

  bool result;

  PMC.PCER  = 1 << ADC_PID; // Enable ADC peripheral clock
  ADC.CR    = _ADC_SWRST;   // Reset
  ADC.CHDR  = 0xff;         // Disable
  result = ADC_CfgTimings (5000000 /*Hz*/, 20/*uSec*/, 600/*nSec*/);
  ADC.CHER  = 0xff;         // Ch select

  return result;
}

// S`lϊJnƏI҂
void ADC_StartConversion (uint16_t *val) {
  ADC.CHER = 0xff;              // Ch select
  ADC.CR = _ADC_START;          // start
  while (!(ADC.SR & (1 << 7))); // wait for conversion
  int ch;
  for (ch = 0; ch < 8; ch++) val[ch] = ADC.CDR[ch];
}

//========================================================
// main
//========================================================
void main (void) {
  uint16_t cnv[8];

  enableIRQ ();

  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));
  PIO_Configure (pins, PIO_LISTSIZE (pins));

#if defined (__UDP__)
  wait (5000);
#endif
  _us_printf ("\nParam check = %d\n", ADC_Init ());

  for (;;) {
    ADC_StartConversion (cnv);
    _us_printf (
      "\r[0]%4d [1]%4d [2]%4d [3]%4d [4]%4d [5]%4d [6]%4d [7]%4d",
      cnv[0], cnv[1], cnv[2], cnv[3], cnv[4], cnv[5], cnv[6], cnv[7]
    );
    wait (1);
  }
}
